# Copyright (c) 2011-2012 Cloudera, Inc. All rights reserved.

from cmf.monitor.json_metrics_utils import get_leaf_dict

class JsonParser(object):
  def __init__(self, json_dict):
    """
    May raise ParseError if the json structure is not what
    we expect.
    """
    self._json = json_dict
    self.datanode = get_leaf_dict(self._json, 'dfs', 'datanode')
    self.jvm = get_leaf_dict(self._json, 'jvm', 'metrics')

#
# This is what the DN json looks like:
#
SAMPLE = """
  {
    "dfs":{
      "datanode":[
        [
          {
            "hostName":"dsom",
            "sessionId":""
          },
          {
            "blockChecksumOp_avg_time":0,
            "blockChecksumOp_num_ops":0,
            "blockReports_avg_time":0,
            "blockReports_num_ops":1,
            "block_verification_failures":0,
            "blocks_read":0,
            "blocks_removed":0,
            "blocks_replicated":0,
            "blocks_verified":0,
            "blocks_written":1,
            "bytes_read":0,
            "bytes_written":4,
            "copyBlockOp_avg_time":0,
            "copyBlockOp_num_ops":0,
            "heartBeats_avg_time":3,
            "heartBeats_num_ops":403,
            "readBlockOp_avg_time":10,
            "readBlockOp_num_ops":1,
            "reads_from_local_client":0,
            "reads_from_remote_client":8,
            "replaceBlockOp_avg_time":0,
            "replaceBlockOp_num_ops":0,
            "volumeFailures":0,
            "writeBlockOp_avg_time":0,
            "writeBlockOp_num_ops":1,
            "writes_from_local_client":1,
            "writes_from_remote_client":0
          }
        ]
      ]
    },
    "jvm":{
      "metrics":[
        [
          {
            "hostName":"dsom",
            "processName":"DataNode",
            "sessionId":""
          },
          {
            "gcCount":4,
            "gcTimeMillis":47,
            "logError":0,
            "logFatal":0,
            "logInfo":1238,
            "logWarn":0,
            "maxMemoryM":888.9375,
            "memHeapCommittedM":118.875,
            "memHeapUsedM":5.7810135,
            "memNonHeapCommittedM":23.1875,
            "memNonHeapUsedM":17.273422,
            "threadsBlocked":1,
            "threadsNew":2,
            "threadsRunnable":3,
            "threadsTerminated":4,
            "threadsTimedWaiting":5,
            "threadsWaiting":6
          }
        ]
      ]
    },
    "rpc":{
      "detailed-metrics":[
        [
          {
            "hostName":"dsom",
            "port":"50020"
          },
          {
            "getProtocolVersion_avg_time":0,
            "getProtocolVersion_num_ops":0
          }
        ]
      ],
      "metrics":[
        [
          {
            "hostName":"dsom",
            "port":"50020"
          },
          {
            "NumOpenConnections":0,
            "ReceivedBytes":0,
            "RpcProcessingTime_avg_time":3,
            "RpcProcessingTime_num_ops":20,
            "RpcQueueTime_avg_time":1,
            "RpcQueueTime_num_ops":10,
            "SentBytes":0,
            "callQueueLen":0,
            "rpcAuthenticationFailures":0,
            "rpcAuthenticationSuccesses":0,
            "rpcAuthorizationFailures":0,
            "rpcAuthorizationSuccesses":0
          }
        ]
      ]
    },
    "ugi":{
      "ugi":[
        [
          {
            "hostName":"dsom"
          },
          {
            "loginFailure_avg_time":0,
            "loginFailure_num_ops":0,
            "loginSuccess_avg_time":0,
            "loginSuccess_num_ops":0
          }
        ]
      ]
    }
  }
  """
