// (c) Copyright 2012 Cloudera, Inc. All rights reserved.
define([
	"cloudera/common/charts/include/heatmap/HeatmapChartUpdater"
], function(HeatmapChartUpdater) {
	describe("HeatmapChartUpdater Tests", function() {
		beforeEach(function() {
			jasmine.Ajax.useMock();
		});

		it("should update the heatmap chart.", function() {

			var $heatmapChartLinkContainer = $("<ul>");
			$heatmapChartLinkContainer.html(
				"<li><a id='chartLink1' class='heatmapChartLink' data-chart-id='chart1' data-test-name='test1'>Chart 1</a></li>" +
				"<li><a id='chartLink2' class='heatmapChartLink' data-chart-id='chart2' data-test-name='test2'>Chart 2</a></li>");

			var $heatmapContainer = $("<div id='heatmapContainer'>");

			$("body")
				.append($heatmapChartLinkContainer)
				.append($heatmapContainer);

			var options = {
				timestamp: 100,
				currentMode: true,
				key: "foo",
				ajaxUrl: "dontcareUrl",
				containerSelector: $heatmapContainer
			};
		  var updater = new HeatmapChartUpdater(options);

			var fakeData = "Dummy Data";
			var fakeUrl;
			var injectFakeData = function() {
				spyOn($, "ajax").andCallFake(function(params) {
					fakeUrl = params.url;
					params.success(fakeData);
				});
			};
			injectFakeData();

			$("#chartLink1").trigger("click");
			expect(fakeUrl).toEqual("dontcareUrl?timestamp=100&currentMode=true&testName=test1&chartId=chart1&key=foo");
			expect($("#heatmapContainer").html()).toEqual(fakeData);

			$("#chartLink2").trigger("click");
			expect(fakeUrl).toEqual("dontcareUrl?timestamp=100&currentMode=true&testName=test2&chartId=chart2&key=foo");

			$("#chartLink1").trigger("click");
			expect(fakeUrl).toEqual("dontcareUrl?timestamp=100&currentMode=true&testName=test1&chartId=chart1&key=foo");

			jQuery.publish("markerDateChanged", [new Date(200), false]);
			$("#chartLink1").trigger("click");
			expect(fakeUrl).toEqual("dontcareUrl?timestamp=200&currentMode=false&testName=test1&chartId=chart1&key=foo");

			$heatmapChartLinkContainer.remove();
			$heatmapContainer.remove();
		});
	});

});
